import java.awt.*;
import java.applet.*;
import java.lang.*;

public class HammerTest extends Applet {
    HammerControls controls;
    public void init() {
	setLayout(new BorderLayout());
	HammerCanvas c = new HammerCanvas();
	add("Center", c);
	add("South", controls = new HammerControls(c));
    }

    public void start() {
	controls.enable();
    }
    

    public void stop() {
	controls.disable();
    }

    public boolean handleEvent(Event e) {
	if (e.id == Event.WINDOW_DESTROY) {
	    System.exit(0);
	}
	return false;
    }


    public static void main(String args[]) {
	Frame f = new Frame("HammerTest");
	HammerTest	hammerTest = new HammerTest();

	hammerTest.init();
	hammerTest.start();

	f.add("Center", hammerTest);
	f.resize(300, 300);
	f.show();
    }
}
    

class HammerCanvas extends Canvas {

public double double2num(double x, int num) {

	x*=Math.pow(10,num);
	int aad1=(int)(x);
	x= (double)(aad1 / Math.pow(10,num));
	return x;
    }  

  
/*   */
int Button_click0 =0;
int choise_click0 =0;

/* Font */
Font font;

/*     mouse */
int  mouse_x;
int  mouse_y;

/*   */
int nmax=70;
double xmin=-2; 
double xmax=2; 
double ymin=-1.6; 
double ymax=1.6;
double a=-1;/*-0.08;*/
double b=0;/*0.655;*/
double g1=4;
    


public void paint(Graphics g) {

   Rectangle r = bounds();
     
/* Font */
   Font fbi=new Font("TimesRoman",Font.BOLD+Font.ITALIC,18);
   g.setFont(fbi);

/*-  Background*/
// g.clearRect(0,0,size().width,size().height);
// setBackground(Color.black);
   if (choise_click0==0) /* Color Color*/
	   setBackground(Color.blue);
   if (choise_click0==1) /* Color Red+++*/
	   setBackground(Color.blue);
   if (choise_click0==2) /* Color Red+++*/
	   setBackground(Color.black);

   double maxcol,maxrow;

/*   */
   if (Button_click0==1){
	maxcol=size().width+108;
	maxrow=size().height;
	}
   else {
	maxcol=size().width;
	maxrow=size().height;
	}

/*     */
/*   */
  int i,j;
  int n,Gd,Gm;
  double dx,dy,x,y,xneu,yneu;

	    
     dx=(xmax-xmin)/maxcol;
     dy=(ymax-ymin)/maxrow;
     Gd=0;
     for(i=0; i<maxcol;i++)
        for(j=0; j<maxrow;j++){
           x=xmin+i*dx;
           y=ymin+j*dy;
           n=0;
           do{
              xneu=x*x-y*y+a;
              yneu=2*x*y+b;
              x=xneu;
              y=yneu;
              n=n+1;
             }while((n<=nmax)&&((x*x+y*y)<=g1));
/*   */
           if (n<=nmax){
/*   */
	      if (choise_click0==0) /* Color */
  	         switch(n%13) {
		       case 0: g.setColor(Color.white); break;
		       case 1: g.setColor(Color.black); break;
		       case 2: g.setColor(Color.lightGray); break;
		       case 3: g.setColor(Color.gray); break;
		       case 4: g.setColor(Color.darkGray); break;
		       case 5: g.setColor(Color.red); break;
		       case 6: g.setColor(Color.green); break;
		       case 7: g.setColor(Color.blue); break;
	 	       case 8: g.setColor(Color.yellow); break;
		       case 9: g.setColor(Color.magenta); break;
		       case 10: g.setColor(Color.cyan); break;
	 	       case 11: g.setColor(Color.pink); break;
		       case 12: g.setColor(Color.orange); break;
		      }
			 
	      if (choise_click0==1) /* Color Red+++*/
	          g.setColor(new Color(17*(n%16),0,0));  // red 
	      if (choise_click0==2) /* Color blue+++*/
 	          g.setColor(new Color(2,2,17*(n%16)));  // blue
	
/*    3D */
	      if (Button_click0==1){  
		 g.drawLine((int)(i-100*j/maxrow),j,
			    (int)(i-100*j/maxrow),j-n%16);
		 }
	      else {
		  g.drawLine(i,j,i,j);
		 }
           } //  if (n<=nmax)
       } // for(j), for(i)
/*   - mouse_click-  */
  if (Button_click0==2){  
     int sx = 10;
     int sy = r.height - 100;
     g.setColor(Color.yellow); //  
     g.drawString("Julia z^2+c",sx,26);	    
     g.drawString("nmax= " + nmax, sx, sy+14); 
     g.drawString("xmin= " + xmin, sx, sy+2*14); 
     g.drawString("xmax= " + xmax, sx, sy+3*14); 
     g.drawString("ymin= " + ymin, sx, sy+4*14); 
     g.drawString("ymax= " + ymax, sx, sy+5*14); 
     g.drawString("g      = " + g1, sx, sy+6*14); 
     g.drawString("c= " + a+"+"+b+"i", sx, sy+7*14); 

/*  mouse_click */
     g.drawString("Mouse Clik=("+double2num(mouse_x*(xmax-xmin)                  /r.width+xmin,2)+","+double2num(-(mouse_y*(ymax-ymin)           /r.height+ymin),2)+")", sx, 40); 

/*   */
  int tt=0;
     while(tt<=r.height){
	 g.drawLine(0, r.height / 2 -tt, r.width, r.height / 2 -tt);		 g.drawLine(0, r.height / 2 +tt, r.width, r.height / 2 +tt);
	 tt+=50;
	}
     tt=0;
     while(tt<=r.width){
         g.drawLine(r.width / 2-tt, 0, r.width / 2-tt, r.height);
         g.drawLine(r.width / 2+tt, 0, r.width / 2+tt, r.height);
         tt+=50;
	}
     g.drawString("o", r.width / 2-4, r.height/2+4); 
     g.drawString("("+ double2num((xmax+xmin)/2,2)+","+double2num(              (ymax+ymin)/2,2)+")", r.width / 2+5, r.height / 2 +20); 
     g.drawString("o", r.width / 2+50-4, r.height/2-46); 
     g.drawString("("+double2num(((xmax+xmin)/2+50*(xmax-xmin)
	    /r.width),2)+","+double2num(((ymax+ymin)/2+50*(ymax-ymin)
	    /r.height),2)+")", r.width / 2+53, r.height / 2 -35); 
   }/*   - mouse_click-  */


} // paint(Graphics g)


public void redraw(int Button_click1, int choise_click1, int aa1,Double 		aa2,Double aa3,Double aa4,Double aa5,Double aa6, Double 		aa7,Double aa8) {

   this.Button_click0 = Button_click1;
   this.choise_click0 = choise_click1;

   this.nmax=aa1;
   this.xmin=aa2.doubleValue(); 
   this.xmax=aa3.doubleValue(); 
   this.ymin=aa4.doubleValue(); 
   this.ymax=aa5.doubleValue();
   this.g1=aa6.doubleValue();
   this.a=aa7.doubleValue(); 
   this.b=aa8.doubleValue();
   repaint();
 } // redraw


public boolean mouseDown(java.awt.Event evt, int x1, int y1) {
	requestFocus();

	this.mouse_x=x1;
	this.mouse_y=y1;
	repaint(); 

	return true;
 } // mouse_click

} // class HammerCanvas 


class HammerControls extends Panel {
 TextField a1;
 TextField a2;
 TextField a3;
 TextField a4;
 TextField a5;
 TextField a6;
 TextField a7;
 TextField a8;

 int Button_click_old;
 int choise_click_old;
 
 HammerCanvas canvas;



public HammerControls(HammerCanvas canvas) {
  
    this.canvas = canvas;
	
    setLayout(new GridLayout(2,5));

/*   */   
    Choice c=new Choice();
        add(new Label("Color=",Label.RIGHT));
        c.addItem("Color");
        c.addItem("Red");
	c.addItem("Blue");
    add(c);

/*   */
    add(new Label("nmax=",Label.RIGHT));
    add(a1 = new TextField("70", 4));
    add(new Label("xmin=",Label.RIGHT));
    add(a2 = new TextField("-2", 4));
    add(new Label("xmax=",Label.RIGHT));
    add(a3 = new TextField("2", 4));
    add(new Label("ymin=",Label.RIGHT));
    add(a4 = new TextField("-1.6", 4));
    add(new Label(" ",Label.RIGHT));
    add(new Label("ymax=",Label.RIGHT));
    add(a5 = new TextField("1.6", 4));
    add(new Label("g=",Label.RIGHT));
    add(a6 = new TextField("4", 4));
    add(new Label("a=",Label.RIGHT));
    add(a7 = new TextField("-1", 4));
    add(new Label("b=",Label.RIGHT));
    add(a8 = new TextField("0", 4));

/*   */
    add(new Button("2D"));
    add(new Button("3D"));
    add(new Button("2D-x,y"));

  } // HammerControls




public boolean action(Event ev, Object arg) {

   int Button_click2=Button_click_old;
   int choise_click2=choise_click_old;

    if (ev.target instanceof Button) {
       String label = (String)arg;
       if(label.equals("2D")) 
	    Button_click2=0;
       else if(label.equals("3D")) 
	       Button_click2=1;
	    else 
		  Button_click2=2;
       }
    else if (ev.target instanceof Choice) 
	    choise_click2=((Choice)ev.target).getSelectedIndex(); 
	 else choise_click2=1; 

    if ((ev.target instanceof Button)||	(ev.target instanceof Choice)){
  	      canvas.redraw(Button_click2,choise_click2,
			  Integer.parseInt(a1.getText().trim()),
			  Double.valueOf(a2.getText().trim()),
			  Double.valueOf(a3.getText().trim()),
			  Double.valueOf(a4.getText().trim()),
			  Double.valueOf(a5.getText().trim()),
			  Double.valueOf(a6.getText().trim()),
			  Double.valueOf(a7.getText().trim()),
			  Double.valueOf(a8.getText().trim()));

  	      Button_click_old=Button_click2;
	      choise_click_old=choise_click2;
   	      return true;
	     }
  return false;
 } // action

} // class HammerControls
	
